/* GCC */
#include <iostream>

struct figure
{
       int left, right, up, down, kol, num; 
};

char c;
int n, a[530][530], left, right, up, down, kol, num = 0, del[250], del_time = 0, sdvig;
figure figur[250];

void dfs( int x, int y )
{
     a[x][y] = num;
     kol++;
     
     if( y < left ) left = y;
     if( y > right ) right = y;
     if( x > down ) down = x;
     if( x < up ) up = x;
     
     if( ( x + 1 < n ) && a[x + 1][y] == -1 ) dfs( x + 1, y );
     if( ( x - 1 >= 0 ) && a[x - 1][y] == -1 ) dfs( x - 1, y );
     if( ( y + 1 < n ) && a[x][y + 1] == -1 ) dfs( x, y + 1 );
     if( ( y - 1 >= 0 ) && a[x][y - 1] == -1 ) dfs( x, y - 1 );
     return;
}

bool equality( figure f, figure s )
{
     if( f.kol != s.kol ) return 0;
     
     int h = f.down - f.up, w = f.right - f.left;
     if( w == s.right - s.left && h == s.down - s.up )
     {
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.up + i][s.left + j] == s.num ) ) goto br1;
              }
         }
         return 1;
         br1:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.down - i][s.left + j] == s.num ) ) goto br2;
              }
         }
         return 1;
         br2:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.up + i][s.right - j] == s.num ) ) goto br3;
              }
         }
         return 1;
         br3:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.down - i][s.right - j] == s.num ) ) goto br4;
              }
         }
         return 1;
         br4:;
     }
     if( h == s.right - s.left && w == s.down - s.up )
     {
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.up + j][s.right - i] == s.num ) ) goto br5;
              }
         }
         return 1;
         br5:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.down - j][s.left + i] == s.num ) ) goto br6;
              }
         }
         return 1;
         br6:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.down - j][s.right - i] == s.num ) ) goto br7;
              }
         }
         return 1;
         br7:;
         
         for( int i = 0; i <= h; i++ )
         {
              for( int j = 0; j <= w; j++ )
              {
                   if( ( a[f.up + i][f.left + j] == f.num ) ^ ( a[s.up + j][s.left + i] == s.num ) ) goto br8;
              }
         }
         return 1;
         br8:;
     }
     return 0;
}

int main()
{
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    
    scanf("%d", &n);
    c = 0;
    while( c != '\n' ) scanf("%c", &c);
    for( int i = 0; i < n; i++ )
    {
         for( int j = 0; j < n; j++ )
         {
              scanf("%c", &c);
              if( c == '*' ) a[i][j] = -1; else a[i][j] = -2;
         }
         scanf("%c", &c);
    }
    
    for( int i = 0; i < n; i++ )
    {
         for( int j = 0; j < n; j++ )
         {
              if( a[i][j] == -1 ) 
              {
                  left = 1000; right = -1000; up = 1000; down = -1000; kol = 0; 
                  dfs( i, j );
                  figur[num].left = left;
                  figur[num].right = right;
                  figur[num].up = up;
                  figur[num].down = down;
                  figur[num].kol = kol;
                  figur[num].num = num;
                  num++;
              }
         }
    }
    
    memset( del, 0, 1000 );
    
    printf("%d ", num);
    num--;
    for( int i = 0; i < num; i++ )
    {
         del_time++;
         for( int j = i + 1; j <= num; j++ )
         {
              if( equality( figur[i], figur[j] ) ) del[j] = del_time;
         }
         sdvig = 0;
         for( int j = i + 1; j <= num; j++ ) if( del[j] == del_time ) sdvig++; else figur[j - sdvig] = figur[j];
         num -= sdvig;
    }
    
    printf("%d\n", num + 1);
    fclose(stdin);
    fclose(stdout);
    return 0;
}
