/* VC */

#include <fstream>
#include <deque>
#include <queue>
#include <set>
/*
void dfs(std::set<std::pair<int,int> >& field,std::set<std::pair<int,int> >& used,std::pair<int,int> current)
{
    if(used.find(current) == used.end())
    {
        used.insert(current);
        std::pair<int,int> next[4];
        next[0] = std::make_pair(current.first+1,current.second);
        next[1] = std::make_pair(current.first,current.second+1);
        next[2] = std::make_pair(current.first-1,current.second);
        next[3] = std::make_pair(current.first,current.second-1);
        for(int j = 0;j < 4;j++)
            if(field.find(next[j]) != field.end())
                dfs(field,used,next[j]);
    }
}

int count(std::set<std::pair<int,int> >& field)
{
    int counter = 0;
    std::set<std::pair<int,int> > used;
    for(std::set<std::pair<int,int> >::iterator i = field.begin();i != field.end();i++)
    {
        if(used.find(*i) == used.end())
        {
            dfs(field,used,*i);
            counter++;
        }
    }
    return counter;
}
*/
int main()
{
    std::ifstream in("test.in");
    int n;
    in >> n;
    std::set<std::pair<int,int> > field;
    for(int i = 0;i < n;i++)
    {
        std::string line;
        std::getline(in,line);
        for(int j = 0;j < line.size();j++)
        {
           if(line[j] != ' ')
           {
                field.insert(std::make_pair(i,j));
           }
        }
    }
    in.close();
    std::set<std::pair<int,int> > used;
    std::queue<std::pair<int,int> > queue;
    int counter = 0;
    for(std::set<std::pair<int,int> >::iterator i = field.begin();i != field.end();i++)
    {
        if(used.find(*i) != used.end())
            continue;
        queue.push(*i);
        while(!queue.empty())
        {
            std::pair<int,int> current = queue.front();
            queue.pop();
            if(used.find(current) == used.end())
            {
                used.insert(current);
                std::pair<int,int> next[4];
                next[0] = std::make_pair(current.first+1,current.second);
                next[1] = std::make_pair(current.first,current.second+1);
                next[2] = std::make_pair(current.first-1,current.second);
                next[3] = std::make_pair(current.first,current.second-1);
                for(int j = 0;j < 4;j++)
                    if(field.find(next[j]) != field.end())
                        queue.push(next[j]);
            }
        }
        counter++;
    }
    std::ofstream out("test.out");
    out << counter << ' ' << counter << std::endl;
    out.close();
}
