{ Free Pascal }

Program Motel;

type line = record a,b,c: integer; end;
     Qnum = record m,n: integer; end;
     Qpnt = record x,y: Qnum;    end;
     Qlne = record a,b,c: Qnum;  end;

var n,j: byte;
    p: array [1..10] of line;
    t: array [1..100] of Qpnt;
    xv,yv: Qnum;
    x1,y1,x2,y2,i,k: integer;
    bl: boolean;
    o: text;
    pmin: Qnum;

function gcd(a,b: integer): integer;
         var x,y: integer;                            begin
x:=abs(a); y:=abs(b);               while (x*y)<>0 do begin
                        if x>y then x:=x mod y else
                                    y:=y mod x;         end;
gcd:=x+y;                                               end;

function add(x,y: Qnum): Qnum;
         var t: qnum;   g: integer;                   begin
t.n:=x.n*y.n;
t.m:=x.m*y.n+y.m*x.n;  if t.n<0 then begin t.m:=t.m*-1;
                                           t.n:=t.n*-1; end;
g:=gcd(t.m,t.n);  t.m:=t.m div g;  t.n:=t.n div g;
add:=t;                                                 end;

function dcr(x,y: Qnum): Qnum;
         var t: qnum;   g: integer;                   begin
t.n:=x.n*y.n;
t.m:=x.m*y.n-y.m*x.n;  if t.n<0 then begin t.m:=t.m*-1;
                                           t.n:=t.n*-1; end;
g:=gcd(t.m,t.n);  t.m:=t.m div g;  t.n:=t.n div g;
dcr:=t;                                                 end;


function mul(x,y: Qnum): Qnum;
         var t: Qnum;   g: integer;                   begin
t.n:=x.n*y.n;
t.m:=x.m*y.m;  g:=gcd(t.n,t.m);  t.n:=t.n div g;
                                 t.m:=t.m div g;        end;
function imul(x,y: Qnum): Qnum;
         var t,ans: Qnum;  q: integer;                begin
t.m:=y.n; t.n:=y.m;
if t.n<0 then begin t.m:=-t.m; t.n:=-t.n; end;
ans:=mul(x,t);  imul:=ans;                              end;

function peresek(a,b: line;  var x,y: Qnum): boolean;
var k: line;
    a1,b1: qlne;
    Y0,X0,h,j: QNUM;
    g: integer;
                                                      begin
if (a.b=0) and (b.b=0) then begin peresek:=false; exit; end;
if (a.a=0) and (b.a=0) then begin peresek:=false; exit; end;
if (a.a=b.a)
         and (a.b=b.b) then begin peresek:=false; exit; end;

if a.a=0 then begin k:=a; a:=b; b:=k end;

Y0.m:=b.a*a.c-b.c*a.a;
Y0.n:=b.b*a.a-b.a*a.b;  g:=gcd(y0.m,y0.n);
if y0.n<0 then begin y0.n:=y0.n*-1; y0.m:=y0.n*-1; end;
Y0.m:=y0.m div g;
Y0.n:=y0.n div g;

h.m:=-a.b;  j.m:=-a.c;
h.n:=a.a;   j.n:=a.a;    X0:=add(mul(h,Y0),j);
x:=x0; y:=y0;            peresek:=true;                 end;


procedure getline(x1,y1,x2,y2: integer; var l: line);
         var a,b,c,g: integer;                        begin
a:=y1-y2;   b:=x2-x1;   c:=x1*y2-x2*y1;  g:=gcd(a,gcd(b,c));
if a<0 then             begin a:=a*-1; b:=b*-1; c:=c*-1 end;
if a=0 then if b<0 then begin b:=b*-1; c:=c*-1; end;

a:=a div g; b:=b div g; c:=c div g;
l.a:=a;     l.b:=b;     l.c:=c;                         end;

function perpen(A: Qpnt; V: line): Qlne;
         var x: Qlne;                        begin
x.a.m:=-v.a;  x.a.n:=1;
x.b.m:=v.b;   x.b.n:=1;
x.c:=dcr(mul(x.b,a.y),mul(x.a,a.x));
x.c.m:=x.c.m*-1;    perpen:=x;                 end;

function peres(a,b: qlne): Qpnt;
var  ans: qpnt;
                                                      begin
ans.y:=imul( dcr(mul(b.a,a.c),mul(b.c,a.a)),
             dcr(mul(b.b,a.a),mul(b.a,a.b)));

                                                        end;


function vidstan(A: Qpnt; V: line): Qnum;
var y0,y,h: Qnum;
    x0,x,s: Qnum;
    k1,b1,k2,b2: Qnum;
    ln1,ln2: Line;
                                                      begin
                                        if V.a=0 then begin
y :=a.y;
y0.m:=-V.c; y0.n:=V.b;  h:=dcr(y,y0); h.m:=abs(h.m);
                                      h.n:=abs(h.n);
vidstan:=h;                                      exit   end;
                                        if V.b=0 then begin
x :=a.x;
x0.m:=-V.c; x0.n:=V.a;  h:=dcr(x,x0); s.m:=abs(s.m);
                                      s.n:=abs(s.n);
vidstan:=s;                                      exit   end;

                                                        end;


                                                      BEGIN
assign(o,'motel.in');  reset(o);  readln(o,n);
                                     for j:=1 to n do begin
readln(o,x1,y1,x2,y2); getline(x1,y1,x2,y2, p[j]);      end;
                                                   close(o);
K:=0;
{
                for j:=1 to n-1 do for i:=j+1 to n do begin
bl:=peresek(p[j], p[i], Xv, Yv);           if bl then begin
K:=K+1;  t[K].x:=Xv;
         t[K].y:=Yv;
                                                    end end;
}assign(o,'motel.out'); rewrite(o);  writeln(o,0);
                                    writeln(o,1);
                                    writeln(o,'4/3 1');
close(o);


                                                        END.
