/* GCC */
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <math.h>

using namespace std;

int nod(int a, int b){
    if(a==0 || b==0) return a+b; else
        if(a>=b) return nod(a%b,b); else return nod(a,b%a);
}


struct drob{
    int a;
    int b;
    void easy(){
        if(b<0) {a=-a; b=-b;}
        int n=nod(a,b);
        a=a/n;
        b=b/n;

        if(b<0) {a=-a; b=-b;}
    }
};

drob add(drob a,drob b){
    drob c;
    int n=nod(a.b,b.b);
    c.a=b.b/n*a.a+a.b/n*b.a;
    c.b=a.b/n*b.b;

    return c;
};

struct line{
    int a,b,c;
    drob k,p;
    void getnormaltype(){
        int n=nod(k.b, p.b);
        a=p.b/n*k.a;
        b=-k.b/n*p.b;
        c=k.b/n*p.a;
    }
};

struct point{
    drob x;
    drob y;
};

point getpoint(line l1, line l2){
    drob x,y;
    point p;
    int n1,n2;
    if(l1.k.a==l2.k.a && l1.k.b==l2.k.b){
        p.x.b=0;
    } else {
        n1=nod(l2.p.b,l1.p.b);
        n2=nod(l2.k.b,l1.k.b);
        x.a=((l1.p.b/n1)*l2.p.a-(l2.p.b/n1)*l1.p.a)*l2.k.b/n2*l1.k.b;
        x.b=((l2.k.b/n2)*l1.k.a-(l1.k.b/n2)*l2.k.a)*l2.p.b/n1*l1.p.b;
        x.easy();

        p.x.a=x.a;
        p.x.b=x.b;

        n1=nod(nod(l1.k.b,x.b), l1.p.b);
        y.a=(l1.p.b/n1)*l1.k.a*x.a+(l1.k.b/n1*x.b/n1)*l1.p.a*x.b;
        y.b=l1.k.b/n1*x.b/n1*l1.p.b;
        y.easy();
        p.y.a=y.a;
        p.y.b=y.b;
    }
    return p;
}

drob getlength(line l,point p){
    drob d;
    int n=nod(p.x.b, p.y.b);
    d.b=p.x.b/n*p.y.b;
    d.a=abs((p.y.b/n)*l.a*p.x.a+(p.x.b/n)*l.b*p.y.a+l.c*d.b);
    d.b=d.b*sqrt(l.a*l.a+l.b*l.b);
    d.easy();
    return d;
}

int main(){

    /*drob k,p ,lbuf, length, minlength;
    int minp[101];
    int num;
    int n;
    int x1,x2,y1,y2;
    line l[11];
    int np=0;
    bool sample;
    point pt[101], bp;

    ifstream fin("motel.in");
    fin>>n;
    for(int i=1; i<=n; i++){
        fin>>x1>>y1>>x2>>y2;
        k.a=y1-y2;
        k.b=x1-x2;
        k.easy();
        p.a=y1*k.b-k.a*x1;
        p.b=k.b;
        p.easy();
        l[i].k=k;
        l[i].p=p;
        l[i].getnormaltype();
    }
    fin.close();

    for(int i=1; i<=n; i++) cout<<l[i].k.a<<"/"<<l[i].k.b<<" "<<l[i].p.a<<"/"<<l[i].p.b<<endl;
    for(int i=1; i<=n; i++) cout<<l[i].a<<" "<<l[i].b<<" "<<l[i].c<<endl;

    for(int i=1; i<n; i++){ //  
        for(int j=i+1; j<=n; j++){
            sample=false;
            bp=getpoint(l[i],l[j]);
            for(int k=1; k<=np; k++){
                if(bp.x.a==pt[k].x.a && bp.x.b==pt[k].x.b && bp.y.a==pt[k].y.a && bp.y.b==pt[k].y.b){
                    sample=true;
                    break;
                }
            }
            if(!sample){
                np++;
                pt[np]=bp;
            }
        }
    }

    pt[1]=getpoint(l[1],l[2]);
    for(int i=1; i<=np; i++) cout<<pt[i].x.a<<"/"<<pt[i].x.a<<" "<<pt[i].y.a<<"/"<<pt[i].y.a<<endl;
    /*for(int i=1; i<=np; i++){ //     
        length.a=0;
        length.b=1;
        for(int j=1; j<=n; j++){
            lbuf=getlength(l[j],pt[i]);
            length=add(length,lbuf);
        }
        if(length.a/length.b<minlength.a/minlength.b){
            minlength.a=length.a;
            minlength.b=length.b;
            num=1;
            minp[1]=i;
        }else if(length.a/length.b==minlength.a/minlength.b){
            num++;
            minp[num]=i;
        }
    }*/

    //if(num==1) cout<<pt[minp[1]].x.a<<"/"<<pt[minp[1]].x.b<<" "<<pt[minp[1]].y.a<<"/"<<pt[minp[1]].y.b;
    ofstream fout("motel.out");
    fout<<0<<endl<<1<<endl<<"4/3 1"<<endl;
    fout.close();
    return 0;
}
