/* GCC */
#include <string>
#include <iostream>
#include <fstream>
#include <math.h>
using namespace std;

struct line
{
   int a,b,c;
};

struct point
{
   int cx,cy,zx,zy;
};

line l[15];
point p[100],pa[100];

int NOD(int a, int b)
{
   int s,d,f;
   s=a;
   d=b;
   if(s==0){return d;}
   if(d==0){return s;}
   while(d>0)
   {
      f=s%d; s=d; d=f;
   }
   return s;
}

point fp(line l1, line l2, bool &f)
{
    int cx,cy,zx,zy,k,z;
    point g;
    g.cx=0; g.zx=0;
    g.cy=0; g.zy=0;
    if(l1.a==l2.a && l1.b==l2.b){f=false; return g;}
    if(l1.a==0 && l2.a==0){f=false; return g;}
    if(l1.b==0 && l2.b==0){f=false; return g;}
    
    if(l1.a==0)
    {
       k=NOD(l1.c,l1.b);
       g.cy=-l1.c/k;g.zy=l1.b/k;
       if(g.zy<0){g.zy=-g.zy;g.cy=-g.cy;}
       g.cx=(-l2.c*g.zy-l2.b*g.cy);
       g.zx=l2.a*g.zy;
       k=NOD(g.cx,g.zx);
       g.cx/=k;
       g.zx/=k;
       if(g.zx<0){g.zx=-g.zx;g.cx=-g.cx;}
       f=true;
       return g;
    }
    
    if(l1.b==0)
    {
       k=NOD(l1.c,l1.a);
       g.cx=-l1.c/k;g.zx=l1.a/k;
       if(g.zx<0){g.zx=-g.zx;g.cx=-g.cx;}
       g.cy=(-l2.c*g.zx-l2.a*g.cx);
       g.zy=l2.b*g.zx;
       k=NOD(g.cy,g.zy);
       g.cy/=k;
       g.zy/=k;
       if(g.zy<0){g.zy=-g.zy;g.cy=-g.cy;}
       f=true;
       return g;
    }
    
    if(l2.a==0)
    {
       k=NOD(l2.c,l2.b);
       g.cy=-l2.c/k;g.zy=l2.b/k;
       if(g.zy<0){g.zy=-g.zy;g.cy=-g.cy;}
       g.cx=(-l1.c*g.zy-l1.b*g.cy);
       g.zx=l1.a*g.zy;
       k=NOD(g.cx,g.zx);
       g.cx/=k;
       g.zx/=k;
       if(g.zx<0){g.zx=-g.zx;g.cx=-g.cx;}
       f=true;
       return g;
    }
    
    if(l2.b==0)
    {
       k=NOD(l2.c,l2.a);
       g.cx=-l2.c/k;g.zx=l2.a/k;
       if(g.zx<0){g.zx=-g.zx;g.cx=-g.cx;}
       g.cy=(-l1.c*g.zx-l1.a*g.cx);
       g.zy=l1.b*g.zx;
       k=NOD(g.cy,g.zy);
       g.cy/=k;
       g.zy/=k;
       if(g.zy<0){g.zy=-g.zy;g.cy=-g.cy;}
       f=true;
       return g;
    }  
    
    g.cy=l2.c*l1.a-l1.c*l2.a;
    g.zy=l1.b*l2.a-l2.b*l1.a;
    k=NOD(g.cy,g.zy);
    g.cy/=k;
    g.zy/=k;
    
    g.cx=l1.c*l2.b-l2.c*l1.b;
    g.zx=l1.b*l2.a-l2.b*l1.a;
    k=NOD(g.cx,g.zx);
    g.cx/=k;
    g.zx/=k;
    f=true;
    return g;
}

int leng(point g, line h)
{
    int j = abs((h.a*g.cx*g.zy+h.b*g.cy*g.zx+h.c*g.zx*g.zy));
    int i = g.zx*g.zy*(int)sqrt(h.a*h.a+h.b*h.b);
    if(i==0){return 0;}
    return j/i;
}

line rl(int x1, int y1, int x2, int y2)
{
   line fl;
   fl.a=y2-y1;
   fl.b=x1-x2;
   fl.c=y1*x2-x1*y2;
   return fl;
}

int main()
{
    int n,i,j,x1,y1,x2,y2,k,ans,la,ka,da,ca,cmi,cma,k1,k2,d1,d2;
    bool f;
    ifstream fin("motel.in");
    ofstream fout("motel.out");
    fin>>n;
    for(i=1; i<=n; i++)
    {
       fin>>x1>>y1>>x2>>y2;
       l[i]=rl(x1,y1,x2,y2);
    }
    k=0;
    point d;
    for(i=1; i<n; i++)
      for(j=i+1; j<=n; j++)
      {
         d=fp(l[i],l[j],f);
         if(f)
         {
            k++;
            p[k]=d;
         }
      }
    if(k==0)
    {
       cmi=1000000;
       cma=-1000000;
       for(i=1; i<=n; i++)
       {
          if(l[i].c>cma){cma=l[i].c;}
          if(l[i].c<cmi){cmi=l[i].c;}
       }
       ca=(cma+cmi)/2;
       d1=1000000;
       d2=1000000;
       k1=0; k2=0;
       for(i=1; i<=n; i++)
       {
          if(abs(ca-l[i].c)<d1){d2=d1;k2=k1;d1=abs(ca-l[i].c);k1=i;}
       }
       la=0;
       for(i=1; i<=n; i++)
       {
          la+=abs(l[i].c-l[k1].c);
       }
       fout<<la<<endl;
       if(n%2==0) {fout<<"-2\n";}
       else {fout<<"-1\n";}
       if(l[k1].a<0){l[k1].a=-l[k1].a;l[k1].b=-l[k1].b;l[k1].c=-l[k1].c;}
       fout<<l[k1].a<<" "<<l[k1].b<<" "<<l[k1].c<<endl;
       if(n%2==0) 
       {
          if(l[k2].a<0){l[k2].a=-l[k2].a;l[k2].b=-l[k2].b;l[k2].c=-l[k2].c;}
          fout<<l[k2].a<<" "<<l[k2].b<<" "<<l[k2].c<<endl;
       }
       return 0;
    }
    la=1000000;
    ka=0;
    for(i=1; i<=k; i++)
    {
       da=0;
       for(j=1; j<=n; j++)
       {
          da+=leng(p[i],l[j]);
       }
       if(da<la){la=da;ka=1;pa[1]=p[i];continue;}
       if(da==la){ka++;pa[ka]=p[i];}
    }
    fout<<la<<endl<<ka<<endl;
    for(i=1; i<=ka; i++)
    {
       fout<<pa[i].cx;
       if(pa[i].zx!=1){fout<<"/"<<pa[i].zx;}
       fout<<" "<<pa[i].cy;
       if(pa[i].zy!=1){fout<<"/"<<pa[i].zy;}
       fout<<endl;
    }
}
